c     Exemple 4: extraction de donnes dcalibres (i.e. en valeurs physique)
c     d'un SDS, sans dimensionnement, mais avec rcupration des infos de type
c     et de dimensionnement. Le rtablissement des valeurs physiques d'origine
c     utilise le calcul par dfaut ainsi qu'un calcul diffrent fourni dans la
c     fonction own_dclb
c     -> Appel des fonctions hgsdsuu et hgsdsuus
c =============================================================================

      program example4

      include 'icahdf.inc'

      include 'netcdf.inc'      ! Pour les constantes "limites"
c     MAXNCDIM: nombre maximal de dimensions d'un SDS

c     Dclaration des variables "paramtres utilisateur"
      character*20
     +     hdf_file,            ! Chemin du fichier HDF
     +     sds_name             ! Noms du SDS  explorer

      integer
     +     n,                   ! Taille du tableau d'octets utilis
     +     nval,                ! Nombre de valeurs du SDS extrait
     +     utype,               ! Type de donne dcalibre du SDS extrait
     +     rank,                ! Nombre de dimensions du SDS extrait
     +     dimsizes(MAXNCDIM)   ! Valeurs des dimensions du SDS extrait

      parameter
     +     (n = 1000)           ! n doit tre suffisant pour la taille du SDS

      byte
     +     data(n)              ! Tableau d'octets utilis pour rcuprer le SDS

      real*8
     +     own_dclb             ! Fonction de dcalibration "utilisateur"

      external own_dclb

c     Initialisations
      data hdf_file, sds_name, data
     +     /'testfile.hdf', 'SDS_I4', n*0/

c     Excution

      if (hgsdsuu(hdf_file, sds_name, n, data, -1, nval, utype, rank,
     +     dimsizes).ge.0) then
         call prntinfo(sds_name, 0, 1, n, nval, -1, utype,
     +        rank, dimsizes, data, .false., 0, -1, 0, '')
         call prntdata('DONNEES EXTRAITES - DCALIBRATION PAR DFAUT',
     +        utype, rank, dimsizes, utype, rank, dimsizes, data)
      else
         print *, 'File ', hdf_file, ': error with SDS ', sds_name
      endif

      if (hgsdsuus(hdf_file, sds_name, n, data, -1, nval, utype, rank,
     +     dimsizes, own_dclb).ge.0) then
         call prntdata('DONNEES EXTRAITES - DCALIBRATION UTILISATEUR',
     +        utype, rank, dimsizes, utype, rank, dimsizes, data)
      else
         print *, 'File ', hdf_file, ': error with SDS ', sds_name
      endif

      end

